﻿using System;
using System.Collections;
using System.Drawing;
using System.IO;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using ScriptPortal.Vegas;

namespace CCTest
{
    public class CCTestDock : DockableControl
    {
        private CCTest.CCMainForm myform = null;

        public CCTestDock() : base("CCTestInternal")
        {
            this.DisplayName = "CCTest";
        }

        public override DockWindowStyle DefaultDockWindowStyle
        {
            get { return DockWindowStyle.Docked; }
        }

        public override Size DefaultFloatingSize
        {
            get { return new Size(640, 480); }
        }

        protected override void OnLoad(EventArgs args)
        {
            myform = new CCTest.CCMainForm(myVegas);
            myform.Dock = DockStyle.Fill;
            this.Controls.Add(myform);
        }

        protected override void OnClosed(EventArgs args)
        {
            base.OnClosed(args);
        }
    }
}


public class CCTestCCM : ICustomCommandModule
{
    public Vegas myVegas = null;
    CustomCommand CCM = new CustomCommand(CommandCategory.View, "CCTest");

    public void InitializeModule(Vegas vegas)
    {
        myVegas = vegas;

        CCM.MenuItemName = "My Test Custom Command";
    }

    public ICollection GetCustomCommands()
    {
        CCM.MenuPopup += this.HandlePICmdMenuPopup;
        CCM.Invoked += this.HandlePICmdInvoked;
        CustomCommand[] cmds = new CustomCommand[] { CCM };
        return cmds;
    }

    void HandlePICmdMenuPopup(Object sender, EventArgs args)
    {
        CCM.Checked = myVegas.FindDockView("CCTestInternal");
    }

    void HandlePICmdInvoked(Object sender, EventArgs args)
    {
        if (!myVegas.ActivateDockView("CCTestInternal"))
        {
            CCTest.CCTestDock CCMDock = new CCTest.CCTestDock();
            CCMDock.AutoLoadCommand = CCM;
            CCMDock.PersistDockWindowState = true;
            myVegas.LoadDockView(CCMDock);
        }
    }

}



